diff --git a/tests/f_dirdata/expect.1 b/tests/f_dirdata/expect.1
new file mode 100644
index 00000000..17e24325
--- /dev/null
+++ b/tests/f_dirdata/expect.1
@@ -0,0 +1,15 @@
+Pass 1: Checking inodes, blocks, and sizes
+Pass 2: Checking directory structure
+Entry 'foobar2' in /ROOT/dir1 (439) dirdata length set incorrectly.
+Clear? yes
+
+Entry 'foobar1' in /ROOT/dir1 (439) dirdata length set incorrectly.
+Clear? yes
+
+Pass 3: Checking directory connectivity
+Pass 4: Checking reference counts
+Pass 5: Checking group summary information
+
+test_filesys: ***** FILE SYSTEM WAS MODIFIED *****
+test_filesys: 543/5000 files (0.9% non-contiguous), 707/5000 blocks
+Exit status is 1
diff --git a/tests/f_dirdata/expect.2 b/tests/f_dirdata/expect.2
new file mode 100644
index 00000000..84cce856
--- /dev/null
+++ b/tests/f_dirdata/expect.2
@@ -0,0 +1,7 @@
+Pass 1: Checking inodes, blocks, and sizes
+Pass 2: Checking directory structure
+Pass 3: Checking directory connectivity
+Pass 4: Checking reference counts
+Pass 5: Checking group summary information
+test_filesys: 543/5000 files (0.9% non-contiguous), 707/5000 blocks
+Exit status is 0
diff --git a/tests/f_dirdata/image.gz b/tests/f_dirdata/image.gz
new file mode 100644
index 0000000000000000000000000000000000000000..ccd900e1c6da30a76be4334767922b2babf0f88a
GIT binary patch
diff --git a/tests/f_dirdata/name b/tests/f_dirdata/name
new file mode 100644
index 00000000..5abb9391
--- /dev/null
+++ b/tests/f_dirdata/name
@@ -0,0 +1 @@
+corrupted dirdata length