diff --git a/tests/f_extents_bad_blk/expect.1 b/tests/f_extents_bad_blk/expect.1
new file mode 100644
index 00000000..b398e1b7
--- /dev/null
+++ b/tests/f_extents_bad_blk/expect.1
@@ -0,0 +1,24 @@
+Pass 1: Checking inodes, blocks, and sizes
+Inode 12 has an invalid extent
+	(logical block 0, invalid physical block 65091, len 16)
+Clear? yes
+
+Inode 12, i_blocks is 3200, should be 3168.  Fix? yes
+
+Pass 2: Checking directory structure
+Pass 3: Checking directory connectivity
+Pass 4: Checking reference counts
+Pass 5: Checking group summary information
+Block bitmap differences:  -(7747--7762)
+Fix? yes
+
+Free blocks count wrong for group #0 (6516, counted=6532).
+Fix? yes
+
+Free blocks count wrong (13908, counted=13924).
+Fix? yes
+
+
+test_filesys: ***** FILE SYSTEM WAS MODIFIED *****
+test_filesys: 12/4016 files (8.3% non-contiguous), 2108/16032 blocks
+Exit status is 1
diff --git a/tests/f_extents_bad_blk/expect.2 b/tests/f_extents_bad_blk/expect.2
new file mode 100644
index 00000000..f7d57b67
--- /dev/null
+++ b/tests/f_extents_bad_blk/expect.2
@@ -0,0 +1,7 @@
+Pass 1: Checking inodes, blocks, and sizes
+Pass 2: Checking directory structure
+Pass 3: Checking directory connectivity
+Pass 4: Checking reference counts
+Pass 5: Checking group summary information
+test_filesys: 12/4016 files (8.3% non-contiguous), 2108/16032 blocks
+Exit status is 0
diff --git a/tests/f_extents_bad_blk/image.gz b/tests/f_extents_bad_blk/image.gz
new file mode 100644
index 0000000000000000000000000000000000000000..03b9967cc58a6bb4c33c2accfff8807d91247bc7
GIT binary patch
diff --git a/tests/f_extents_bad_blk/name b/tests/f_extents_bad_blk/name
new file mode 100644
index 00000000..15cbbe62
--- /dev/null
+++ b/tests/f_extents_bad_blk/name
@@ -0,0 +1 @@
+extent pointing to non-existent block